%define apxs    %{_sbindir}/apxs

%define real_name mod_cluster

Summary:    Apache version 2.2.X HTTP load balancer
Name:       mod_cluster_ap22
Version:    1.2.7
Release:    1
License:    LGPLv2
URL:        http://jboss.org/mod_cluster
Group:      System Environment/Daemons
Source0:    %{real_name}-%{version}.Final.tar.gz
Source1:    %{real_name}.conf
Source2:    %{real_name}.README

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  apr-devel >= 1.4.6-2
BuildRequires:  apr-util-devel >= 1.3.10-3
BuildRequires:  httpd-devel >= 2.2.27-2
BuildRequires:  httpd-devel < 2.3
PreReq:         apr >= 1.4.6-2
PreReq:         apr-util >= 1.3.10-3
PreReq:         httpd >= 2.2.27-2
PreReq:         httpd < 2.3

Provides:       %{real_name}


%description
Mod_cluster is an httpd-based load balancer. Like mod_jk and mod_proxy,
mod_cluster uses a communication channel to forward requests from httpd to one
of a set of application server nodes. Unlike mod_jk and mod_proxy, mod_cluster
leverages an additional connection between the application server nodes and
httpd. The application server nodes use this connection to transmit server-side
load balance factors and lifecycle events back to httpd via a custom set of
HTTP methods, affectionately called the Mod-Cluster Management Protocol (MCMP).
This additional feedback channel allows mod_cluster to offer a level of
intelligence and granularity not found in other load balancing solutions.


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q -n %{real_name}-%{version}.Final


%build
cd native

module_dirs="advertise mod_manager mod_proxy_cluster mod_slotmem"

for dir in ${module_dirs} ; do
    cd ${dir}
        sh buildconf
        ./configure \
             --with-apxs=%{apxs}
        make %{?_smp_mflags}
    cd ..
done


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
chmod 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra

cp %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
chmod 0644 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/*

cp %{SOURCE2} README

cd native

module_dirs="advertise mod_manager mod_proxy_cluster mod_slotmem"

for dir in ${module_dirs} ; do
    cd ${dir}
        cp ./*.so ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules
    cd ..
done


%preun
echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"


%post
echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc README lgpl.txt
%config(noreplace) %{_sysconfdir}/httpd/conf/extra/*.conf
%{_libdir}/httpd/modules/*


%changelog
* Tue Sep 23 2014 Michael Perzl <michael@perzl.org> - 1.2.7-1
- updated to version 1.2.7

* Tue Sep 23 2014 Michael Perzl <michael@perzl.org> - 1.2.6-1
- updated to version 1.2.6

* Tue Sep 23 2014 Michael Perzl <michael@perzl.org> - 1.2.5-1
- updated to version 1.2.5

* Thu Aug 22 2013 Michael Perzl <michael@perzl.org> - 1.2.4-1
- first version for AIX V5.1 and higher
